Index: cam_periph.c
===================================================================
--- cam_periph.c	(revision 245046)
+++ cam_periph.c	(working copy)
@@ -744,6 +744,9 @@ cam_periph_mapmem(union ccb *ccb, struct cam_perip
 		if ((ccb->ccb_h.flags & CAM_DIR_MASK) == CAM_DIR_NONE)
 			return(0);
 
+		if ((uintptr_t)ccb->ataio.data_ptr % sizeof(uint16_t) != 0)
+			return (EINVAL);
+
 		data_ptrs[0] = &ccb->ataio.data_ptr;
 		lengths[0] = ccb->ataio.dxfer_len;
 		dirs[0] = ccb->ccb_h.flags & CAM_DIR_MASK;
